# std::multimap< Key, Type, Compare, Alloc > Class Template Reference
[Containers, Associative Containers]

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time. More...

`#include <stl_multimap.h>`

Inheritance diagram for std::multimap< Key, Type, Compare, Alloc >:

[legend]
List of all members.

## Public Member Functions

| multimap ()
| Default constructor creates no elements.
| multimap (const Compare &comp, const allocator_type &a=allocator_type())
| Default constructor creates no elements.
| multimap (const multimap &x)
| Multimap copy constructor.
template<typename InputIterator> | multimap (InputIterator first, InputIterator last)
| Builds a multimap from a range.
template<typename InputIterator> | multimap (InputIterator first, InputIterator last, const Compare &comp, const allocator_type &a=allocator_type())
| Builds a multimap from a range.
multimap & | operator= (const multimap &x)
| Multimap assignment operator.
allocator_type | get_allocator () const
| Get a copy of the memory allocation object.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
bool | empty () const
size_type | size () const
size_type | max_size () const
iterator | insert (const value_type &x)
| Inserts a std::pair into the multimap.
iterator | insert (iterator position, const value_type &x)
| Inserts a std::pair into the multimap.
template<typename InputIterator> void | insert (InputIterator first, InputIterator last)
| A template function that attemps to insert a range of elements.
void | erase (iterator position)
| Erases an element from a multimap.
size_type | erase (const key_type &x)
| Erases elements according to the provided key.
void | erase (iterator first, iterator last)
| Erases a [first,last) range of elements from a multimap.
void | swap (multimap &x)
| Swaps data with another multimap.
void | clear ()
key_compare | key_comp () const
value_compare | value_comp () const
iterator | find (const key_type &x)
| Tries to locate an element in a multimap.
const_iterator | find (const key_type &x) const
| Tries to locate an element in a multimap.
size_type | count (const key_type &x) const
| Finds the number of elements with given key.
iterator | lower_bound (const key_type &x)
| Finds the beginning of a subsequence matching given key.
const_iterator | lower_bound (const key_type &x) const
| Finds the beginning of a subsequence matching given key.
iterator | upper_bound (const key_type &x)
| Finds the end of a subsequence matching given key.
const_iterator | upper_bound (const key_type &x) const
| Finds the end of a subsequence matching given key.
pair< iterator, iterator > | equal_range (const key_type &x)
| Finds a subsequence matching given key.
pair< const_iterator, const_iterator > | equal_range (const key_type &x) const
| Finds a subsequence matching given key.

## Detailed Description

### template<typename Key, typename Type, typename Compare, typename Alloc>
class std::multimap< Key, Type, Compare, Alloc >

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time.

Meets the requirements of a container, a reversible container, and an associative container (using equivalent keys). For a `multimap<Key,T>` the key_type is Key, the mapped_type is T, and the value_type is std::pair<const Key,T>.

Multimaps support bidirectional iterators.

Definition at line 107 of file stl_multimap.h.

## Constructor & Destructor Documentation

template<typename Key, typename Type, typename Compare, typename Alloc>
std::multimap< Key, Type, Compare, Alloc >::multimap | ( |  | ) | `[inline]`

| Default constructor creates no elements. Definition at line 163 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
std::multimap< Key, Type, Compare, Alloc >::multimap | ( | const Compare & | comp,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 171 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
std::multimap< Key, Type, Compare, Alloc >::multimap | ( | const multimap< Key, Type, Compare, Alloc > & | x | ) | `[inline]`

Multimap copy constructor.

Parameters:

  | x | A multimap of identical element and allocator types.

The newly-created multimap uses a copy of the allocation object used by x.

Definition at line 182 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
template<typename InputIterator>
std::multimap< Key, Type, Compare, Alloc >::multimap | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

Builds a multimap from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 195 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
template<typename InputIterator>
std::multimap< Key, Type, Compare, Alloc >::multimap | ( | InputIterator | first,
|  | InputIterator | last,
|  | const Compare & | comp,
|  | const allocator_type & | a = `allocator_type()`
| ) | `[inline]`

Builds a multimap from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | comp | A comparison functor.
  | a | An allocator object.

Create a multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 211 of file stl_multimap.h.

## Member Function Documentation

template<typename Key, typename Type, typename Compare, typename Alloc>
const_iterator std::multimap< Key, Type, Compare, Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first pair in the multimap. Iteration is done in ascending order according to the keys. Definition at line 261 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::begin | ( |  | ) | `[inline]`

| Returns a read/write iterator that points to the first pair in the multimap. Iteration is done in ascending order according to the keys. Definition at line 252 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
void std::multimap< Key, Type, Compare, Alloc >::clear | ( |  | ) | `[inline]`

| Erases all elements in a multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 454 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
size_type std::multimap< Key, Type, Compare, Alloc >::count | ( | const key_type & | x | ) | const`[inline]`

Finds the number of elements with given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Number of elements with specified key.

Definition at line 511 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
bool std::multimap< Key, Type, Compare, Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the multimap is empty. Definition at line 321 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
const_iterator std::multimap< Key, Type, Compare, Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last pair in the multimap. Iteration is done in ascending order according to the keys. Definition at line 279 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::end | ( |  | ) | `[inline]`

| Returns a read/write iterator that points one past the last pair in the multimap. Iteration is done in ascending order according to the keys. Definition at line 270 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
pair<const_iterator,const_iterator> std::multimap< Key, Type, Compare, Alloc >::equal_range | ( | const key_type & | x | ) | const`[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

Definition at line 595 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
pair<iterator,iterator> std::multimap< Key, Type, Compare, Alloc >::equal_range | ( | const key_type & | x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pairs to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

Definition at line 578 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
void std::multimap< Key, Type, Compare, Alloc >::erase | ( | iterator | first,
|  | iterator | last
| ) | `[inline]`

Erases a [first,last) range of elements from a multimap.

Parameters:

  | first | Iterator pointing to the start of the range to be erased.
  | last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 429 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
size_type std::multimap< Key, Type, Compare, Alloc >::erase | ( | const key_type & | x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  | x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all elements located by the given key from a multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 414 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
void std::multimap< Key, Type, Compare, Alloc >::erase | ( | iterator | position | ) | `[inline]`

Erases an element from a multimap.

Parameters:

  | position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 399 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
const_iterator std::multimap< Key, Type, Compare, Alloc >::find | ( | const key_type & | x | ) | const`[inline]`

Tries to locate an element in a multimap.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 502 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::find | ( | const key_type & | x | ) | `[inline]`

Tries to locate an element in a multimap.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 487 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
allocator_type std::multimap< Key, Type, Compare, Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 242 of file stl_multimap.h. Referenced by std::multimap< Key, Type, Compare, Allocator >::get_allocator().

template<typename Key, typename Type, typename Compare, typename Alloc>
template<typename InputIterator>
void std::multimap< Key, Type, Compare, Alloc >::insert | ( | InputIterator | first,
|  | InputIterator | last
| ) | `[inline]`

A template function that attemps to insert a range of elements.

Parameters:

  | first | Iterator pointing to the start of the range to be inserted.
  | last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 385 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::insert | ( | iterator | position,
|  | const value_type & | x
| ) | `[inline]`

Inserts a std::pair into the multimap.

Parameters:

  | position | An iterator that serves as a hint as to where the pair should be inserted.
  | x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the multimap. Contrary to a std::map the multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on "hinting".

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 372 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::insert | ( | const value_type & | x | ) | `[inline]`

Inserts a std::pair into the multimap.

Parameters:

  | x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the multimap. Contrary to a std::map the multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted.

Insertion requires logarithmic time.

Definition at line 348 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
key_compare std::multimap< Key, Type, Compare, Alloc >::key_comp | ( |  | ) | const`[inline]`

| Returns the key comparison object out of which the multimap was constructed. Definition at line 463 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
const_iterator std::multimap< Key, Type, Compare, Alloc >::lower_bound | ( | const key_type & | x | ) | const`[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful the iterator will point to the next greatest element or, if no such greater element exists, to end().

Definition at line 541 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::lower_bound | ( | const key_type & | x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 526 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
size_type std::multimap< Key, Type, Compare, Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the maximum size of the multimap. Definition at line 331 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
multimap& std::multimap< Key, Type, Compare, Alloc >::operator= | ( | const multimap< Key, Type, Compare, Alloc > & | x | ) | `[inline]`

Multimap assignment operator.

Parameters:

  | x | A multimap of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 234 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
const_reverse_iterator std::multimap< Key, Type, Compare, Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last pair in the multimap. Iteration is done in descending order according to the keys. Definition at line 297 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
reverse_iterator std::multimap< Key, Type, Compare, Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last pair in the multimap. Iteration is done in descending order according to the keys. Definition at line 288 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
const_reverse_iterator std::multimap< Key, Type, Compare, Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first pair in the multimap. Iteration is done in descending order according to the keys. Definition at line 315 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
reverse_iterator std::multimap< Key, Type, Compare, Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first pair in the multimap. Iteration is done in descending order according to the keys. Definition at line 306 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
size_type std::multimap< Key, Type, Compare, Alloc >::size | ( |  | ) | const`[inline]`

| Returns the size of the multimap. Definition at line 326 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
void std::multimap< Key, Type, Compare, Alloc >::swap | ( | multimap< Key, Type, Compare, Alloc > & | x | ) | `[inline]`

Swaps data with another multimap.

Parameters:

  | x | A multimap of the same element and allocator types.

This exchanges the elements between two multimaps in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 444 of file stl_multimap.h.

Referenced by std::swap().

template<typename Key, typename Type, typename Compare, typename Alloc>
const_iterator std::multimap< Key, Type, Compare, Alloc >::upper_bound | ( | const key_type & | x | ) | const`[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first iterator greater than key, or end().

Definition at line 561 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
iterator std::multimap< Key, Type, Compare, Alloc >::upper_bound | ( | const key_type & | x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Definition at line 551 of file stl_multimap.h.

template<typename Key, typename Type, typename Compare, typename Alloc>
value_compare std::multimap< Key, Type, Compare, Alloc >::value_comp | ( |  | ) | const`[inline]`

| Returns a value comparison object, built from the key comparison object out of which the multimap was constructed. Definition at line 471 of file stl_multimap.h.

The documentation for this class was generated from the following file:

- stl_multimap.h